#include "DistanceCubeMapRenderTechnique.h"


DistanceCubeMapRenderTechnique::DistanceCubeMapRenderTechnique(unsigned long startFrame,
												unsigned long cubeMapUpdateInterval,
												unsigned int cubeMapResolution,												
												bool useDistCalc,
												bool useFaceAngleCalc,
												float distTolerance,
												float angleTolerance,
												bool updateAllFace,
												bool renderSelf,
												bool renderEnvironment,
												int layer,
												ElementaryRenderable* parentRenderable,
												TechniqueGroup* parentTechniqueGroup)
											
												:CubeMapRenderTechnique( startFrame, cubeMapUpdateInterval, cubeMapResolution,
																					useDistCalc, useFaceAngleCalc, distTolerance, angleTolerance,
																					updateAllFace, renderSelf, renderEnvironment, layer,
																					parentRenderable, parentTechniqueGroup),
												 RenderTechnique(parentRenderable, parentTechniqueGroup)
{
	switch(layer)
	{
		case 0:
			cubemapLayer = ILLUMRUN_DISTANCE_CUBEMAP;
			break;
		case 1:
			cubemapLayer = ILLUMRUN_DISTANCE_CUBEMAP_L1;
			break;
		case 2:
			cubemapLayer = ILLUMRUN_DISTANCE_CUBEMAP_L2;
			break;
		case 3:
			cubemapLayer = ILLUMRUN_DISTANCE_CUBEMAP_L3;
			break;
		case 4:
			cubemapLayer = ILLUMRUN_DISTANCE_CUBEMAP_L4;
			break;
		case 5:
			cubemapLayer = ILLUMRUN_DISTANCE_CUBEMAP_L5;
			break;
		case 6:
			cubemapLayer = ILLUMRUN_DISTANCE_CUBEMAP_L6;
			break;
	}
}

DistanceCubeMapRenderTechnique::~DistanceCubeMapRenderTechnique()
{
	
}

void DistanceCubeMapRenderTechnique::runChanged(RenderingRunType runType, RenderingRun* run)
{
	if(runType == cubemapLayer)
		distanceCubeMapRunChanged(run);
}

void DistanceCubeMapRenderTechnique::runUpdated(RenderingRunType runType, RenderingRun* run)
{
	if(runType == cubemapLayer)
		distanceCubeMapRunUpdated(run);
}

 void DistanceCubeMapRenderTechnique::update(unsigned long frameNum)
{	
	sharedRuns->updateRun(cubemapLayer, frameNum);	
}
